org.apache.xml.utils

## Class XMLStringDefault

- java.lang.Object
- - org.apache.xml.utils.XMLStringDefault

All Implemented Interfaces:
  XMLString

    public class XMLStringDefault
    extends java.lang.Object
    implements XMLString

The default implementation of the XMLString interface, which is just a simple wrapper of a String object.

### Constructor Summary

Constructors
Constructor and Description
`XMLStringDefault(java.lang.String str)` Create a XMLStringDefault object from a String

### Method Summary

Methods
`char` `charAt(int index)` Returns the character at the specified index.
`int` `compareTo(XMLString anotherString)` Compares two strings lexicographically.
`int` `compareToIgnoreCase(XMLString str)` Compares two strings lexicographically, ignoring case considerations.
`XMLString` `concat(java.lang.String str)` Concatenates the specified string to the end of this string.
`void` `dispatchAsComment(LexicalHandler lh)` Directly call the comment method on the passed LexicalHandler for the string-value.
`void` `dispatchCharactersEvents(ContentHandler ch)` Directly call the characters method on the passed ContentHandler for the string-value.
`boolean` `endsWith(java.lang.String suffix)` Tests if this string ends with the specified suffix.
`boolean` `equals(java.lang.Object anObject)` Compares this string to the specified object.
`boolean` `equals(java.lang.String obj2)` Compares this string to the specified `String`.
`boolean` `equals(XMLString anObject)` Compares this string to the specified object.
`boolean` `equalsIgnoreCase(java.lang.String anotherString)` Compares this `String` to another `String`, ignoring case considerations.
`XMLString` `fixWhiteSpace(boolean trimHead, boolean trimTail, boolean doublePunctuationSpaces)` Conditionally trim all leading and trailing whitespace in the specified String.
`void` `getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)` Copies characters from this string into the destination character array.
`int` `hashCode()` Returns a hashcode for this string.
`boolean` `hasString()` Tell if this object contains a java String object.
`int` `indexOf(int ch)` Returns the index within this string of the first occurrence of the specified character.
`int` `indexOf(int ch, int fromIndex)` Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.
`int` `indexOf(java.lang.String str)` Returns the index within this string of the first occurrence of the specified substring.
`int` `indexOf(java.lang.String str, int fromIndex)` Returns the index within this string of the first occurrence of the specified substring, starting at the specified index.
`int` `indexOf(XMLString str)` Returns the index within this string of the first occurrence of the specified substring.
`int` `lastIndexOf(int ch)` Returns the index within this string of the last occurrence of the specified character.
`int` `lastIndexOf(int ch, int fromIndex)` Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index.
`int` `lastIndexOf(java.lang.String str)` Returns the index within this string of the rightmost occurrence of the specified substring.
`int` `lastIndexOf(java.lang.String str, int fromIndex)` Returns the index within this string of the last occurrence of the specified substring.
`int` `length()` Returns the length of this string.
`boolean` `startsWith(java.lang.String prefix)` Tests if this string starts with the specified prefix.
`boolean` `startsWith(java.lang.String prefix, int toffset)` Tests if this string starts with the specified prefix beginning a specified index.
`boolean` `startsWith(XMLString prefix)` Tests if this string starts with the specified prefix.
`boolean` `startsWith(XMLString prefix, int toffset)` Tests if this string starts with the specified prefix beginning a specified index.
`XMLString` `substring(int beginIndex)` Returns a new string that is a substring of this string.
`XMLString` `substring(int beginIndex, int endIndex)` Returns a new string that is a substring of this string.
`double` `toDouble()` Convert a string to a double -- Allowed input is in fixed notation ddd.fff.
`XMLString` `toLowerCase()` Converts all of the characters in this `String` to lower case using the rules of the default locale, which is returned by `Locale.getDefault`.
`XMLString` `toLowerCase(java.util.Locale locale)` Converts all of the characters in this `String` to lower case using the rules of the given `Locale`.
`java.lang.String` `toString()` This object (which is already a string!)
`XMLString` `toUpperCase()` Converts all of the characters in this `String` to upper case using the rules of the default locale, which is returned by `Locale.getDefault`.
`XMLString` `toUpperCase(java.util.Locale locale)` Converts all of the characters in this `String` to upper case using the rules of the given locale.
`XMLString` `trim()` Removes white space from both ends of this string.

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### XMLStringDefault

    public XMLStringDefault(java.lang.String str)

Create a XMLStringDefault object from a String

### Method Detail

#### dispatchCharactersEvents

    public void dispatchCharactersEvents(ContentHandler ch)
                                  throws SAXException

Directly call the characters method on the passed ContentHandler for the string-value. Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.

Specified by:
  `dispatchCharactersEvents` in interface `XMLString`
Parameters:
  `ch` - A non-null reference to a ContentHandler.
Throws:
  `SAXException`

#### dispatchAsComment

    public void dispatchAsComment(LexicalHandler lh)
                           throws SAXException

Directly call the comment method on the passed LexicalHandler for the string-value.

Specified by:
  `dispatchAsComment` in interface `XMLString`
Parameters:
  `lh` - A non-null reference to a LexicalHandler.
Throws:
  `SAXException`

#### fixWhiteSpace

    public XMLString fixWhiteSpace(boolean trimHead,
                          boolean trimTail,
                          boolean doublePunctuationSpaces)

Conditionally trim all leading and trailing whitespace in the specified String. All strings of white space are replaced by a single space character (#x20), except spaces after punctuation which receive double spaces if doublePunctuationSpaces is true. This function may be useful to a formatter, but to get first class results, the formatter should probably do it's own white space handling based on the semantics of the formatting object.

Specified by:
  `fixWhiteSpace` in interface `XMLString`
Parameters:
  `trimHead` - Trim leading whitespace?
  `trimTail` - Trim trailing whitespace?
  `doublePunctuationSpaces` - Use double spaces for punctuation?
Returns:
  The trimmed string.

#### length

    public int length()

Returns the length of this string.

Specified by:
  `length` in interface `XMLString`
Returns:
  the length of the sequence of characters represented by this object.

#### charAt

    public char charAt(int index)

Returns the character at the specified index. An index ranges from `0` to `length() - 1`. The first character of the sequence is at index `0`, the next at index `1`, and so on, as for array indexing.

Specified by:
  `charAt` in interface `XMLString`
Parameters:
  `index` - the index of the character.
Returns:
  the character at the specified index of this string. The first character is at index `0`.
Throws:
  `java.lang.IndexOutOfBoundsException` - if the `index` argument is negative or not less than the length of this string.

#### getChars

    public void getChars(int srcBegin,
                int srcEnd,
                char[] dst,
                int dstBegin)

Copies characters from this string into the destination character array.

Specified by:
  `getChars` in interface `XMLString`
Parameters:
  `srcBegin` - index of the first character in the string to copy.
  `srcEnd` - index after the last character in the string to copy.
  `dst` - the destination array.
  `dstBegin` - the start offset in the destination array.
Throws:
  `java.lang.IndexOutOfBoundsException` - If any of the following is true:
  - `srcBegin` is negative.
  - `srcBegin` is greater than `srcEnd`
  - `srcEnd` is greater than the length of this string
  - `dstBegin` is negative
  - `dstBegin+(srcEnd-srcBegin)` is larger than `dst.length`
  `java.lang.NullPointerException` - if `dst` is `null`

#### equals

    public boolean equals(java.lang.String obj2)

Compares this string to the specified `String`. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.

Specified by:
  `equals` in interface `XMLString`
Parameters:
  `obj2` - the object to compare this `String` against.
Returns:
  `true` if the `String`s are equal; `false` otherwise.
See Also:
  `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

#### equals

    public boolean equals(XMLString anObject)

Compares this string to the specified object. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.

Specified by:
  `equals` in interface `XMLString`
Parameters:
  `anObject` - the object to compare this `String` against.
Returns:
  `true` if the `String` are equal; `false` otherwise.
See Also:
  `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

#### equals

    public boolean equals(java.lang.Object anObject)

Compares this string to the specified object. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.

Specified by:
  `equals` in interface `XMLString`
Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `anObject` - the object to compare this `String` against.
Returns:
  `true` if the `String` are equal; `false` otherwise.
See Also:
  `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

#### equalsIgnoreCase

    public boolean equalsIgnoreCase(java.lang.String anotherString)

Compares this `String` to another `String`, ignoring case considerations. Two strings are considered equal ignoring case if they are of the same length, and corresponding characters in the two strings are equal ignoring case.

Specified by:
  `equalsIgnoreCase` in interface `XMLString`
Parameters:
  `anotherString` - the `String` to compare this `String` against.
Returns:
  `true` if the argument is not `null` and the `String`s are equal, ignoring case; `false` otherwise.
See Also:
  `equals(Object)`, `Character.toLowerCase(char)`, `Character.toUpperCase(char)`

#### compareTo

    public int compareTo(XMLString anotherString)

Compares two strings lexicographically.

Specified by:
  `compareTo` in interface `XMLString`
Parameters:
  `anotherString` - the `String` to be compared.
Returns:
  the value `0` if the argument string is equal to this string; a value less than `0` if this string is lexicographically less than the string argument; and a value greater than `0` if this string is lexicographically greater than the string argument.
Throws:
  `java.lang.NullPointerException` - if `anotherString` is `null`.

#### compareToIgnoreCase

    public int compareToIgnoreCase(XMLString str)

Compares two strings lexicographically, ignoring case considerations. This method returns an integer whose sign is that of `this.toUpperCase().toLowerCase().compareTo( str.toUpperCase().toLowerCase())`.

Note that this method does not take locale into account, and will result in an unsatisfactory ordering for certain locales. The java.text package provides collators to allow locale-sensitive ordering.

Specified by:
  `compareToIgnoreCase` in interface `XMLString`
Parameters:
  `str` - the `String` to be compared.
Returns:
  a negative integer, zero, or a positive integer as the the specified String is greater than, equal to, or less than this String, ignoring case considerations.
Since:
  1.2
See Also:
  `Collator.compare(String, String)`

#### startsWith

    public boolean startsWith(java.lang.String prefix,
                     int toffset)

Tests if this string starts with the specified prefix beginning a specified index.

Specified by:
  `startsWith` in interface `XMLString`
Parameters:
  `prefix` - the prefix.
  `toffset` - where to begin looking in the string.
Returns:
  `true` if the character sequence represented by the argument is a prefix of the substring of this object starting at index `toffset`; `false` otherwise. The result is `false` if `toffset` is negative or greater than the length of this `String` object; otherwise the result is the same as the result of the expression

                this.subString(toffset).startsWith(prefix)

Throws:
  `java.lang.NullPointerException` - if `prefix` is `null`.

#### startsWith

    public boolean startsWith(XMLString prefix,
                     int toffset)

Tests if this string starts with the specified prefix beginning a specified index.

Specified by:
  `startsWith` in interface `XMLString`
Parameters:
  `prefix` - the prefix.
  `toffset` - where to begin looking in the string.
Returns:
  `true` if the character sequence represented by the argument is a prefix of the substring of this object starting at index `toffset`; `false` otherwise. The result is `false` if `toffset` is negative or greater than the length of this `String` object; otherwise the result is the same as the result of the expression

                this.subString(toffset).startsWith(prefix)

Throws:
  `java.lang.NullPointerException` - if `prefix` is `null`.

#### startsWith

    public boolean startsWith(java.lang.String prefix)

Tests if this string starts with the specified prefix.

Specified by:
  `startsWith` in interface `XMLString`
Parameters:
  `prefix` - the prefix.
Returns:
  `true` if the character sequence represented by the argument is a prefix of the character sequence represented by this string; `false` otherwise. Note also that `true` will be returned if the argument is an empty string or is equal to this `String` object as determined by the `equals(Object)` method.
Throws:
  `java.lang.NullPointerException` - if `prefix` is `null`.
Since:
  JDK1. 0

#### startsWith

    public boolean startsWith(XMLString prefix)

Tests if this string starts with the specified prefix.

Specified by:
  `startsWith` in interface `XMLString`
Parameters:
  `prefix` - the prefix.
Returns:
  `true` if the character sequence represented by the argument is a prefix of the character sequence represented by this string; `false` otherwise. Note also that `true` will be returned if the argument is an empty string or is equal to this `String` object as determined by the `equals(Object)` method.
Throws:
  `java.lang.NullPointerException` - if `prefix` is `null`.
Since:
  JDK1. 0

#### endsWith

    public boolean endsWith(java.lang.String suffix)

Tests if this string ends with the specified suffix.

Specified by:
  `endsWith` in interface `XMLString`
Parameters:
  `suffix` - the suffix.
Returns:
  `true` if the character sequence represented by the argument is a suffix of the character sequence represented by this object; `false` otherwise. Note that the result will be `true` if the argument is the empty string or is equal to this `String` object as determined by the `equals(Object)` method.
Throws:
  `java.lang.NullPointerException` - if `suffix` is `null`.

#### hashCode

    public int hashCode()

Returns a hashcode for this string. The hashcode for a `String` object is computed as

>      s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1]

using `int` arithmetic, where `s[i]` is the ith character of the string, `n` is the length of the string, and `^` indicates exponentiation. (The hash value of the empty string is zero.)

Specified by:
  `hashCode` in interface `XMLString`
Overrides:
  `hashCode` in class `java.lang.Object`
Returns:
  a hash code value for this object.

#### indexOf

    public int indexOf(int ch)

Returns the index within this string of the first occurrence of the specified character. If a character with value `ch` occurs in the character sequence represented by this `String` object, then the index of the first such occurrence is returned -- that is, the smallest value k such that:

>      this.charAt(k) == ch

is `true`. If no such character occurs in this string, then `-1` is returned.

Specified by:
  `indexOf` in interface `XMLString`
Parameters:
  `ch` - a character.
Returns:
  the index of the first occurrence of the character in the character sequence represented by this object, or `-1` if the character does not occur.

#### indexOf

    public int indexOf(int ch,
              int fromIndex)

Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.

If a character with value `ch` occurs in the character sequence represented by this `String` object at an index no smaller than `fromIndex`, then the index of the first such occurrence is returned--that is, the smallest value k such that:

>      (this.charAt(k) == ch) && (k >= fromIndex)

is true. If no such character occurs in this string at or after position `fromIndex`, then `-1` is returned.

There is no restriction on the value of `fromIndex`. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: `-1` is returned.

Specified by:
  `indexOf` in interface `XMLString`
Parameters:
  `ch` - a character.
  `fromIndex` - the index to start the search from.
Returns:
  the index of the first occurrence of the character in the character sequence represented by this object that is greater than or equal to `fromIndex`, or `-1` if the character does not occur.

#### lastIndexOf

    public int lastIndexOf(int ch)

Returns the index within this string of the last occurrence of the specified character. That is, the index returned is the largest value k such that:

>      this.charAt(k) == ch

is true. The String is searched backwards starting at the last character.

Specified by:
  `lastIndexOf` in interface `XMLString`
Parameters:
  `ch` - a character.
Returns:
  the index of the last occurrence of the character in the character sequence represented by this object, or `-1` if the character does not occur.

#### lastIndexOf

    public int lastIndexOf(int ch,
                  int fromIndex)

Returns the index within this string of the last occurrence of the specified character, searching backward starting at the specified index. That is, the index returned is the largest value k such that:

>      this.charAt(k) == ch) && (k <= fromIndex)

is true.

Specified by:
  `lastIndexOf` in interface `XMLString`
Parameters:
  `ch` - a character.
  `fromIndex` - the index to start the search from. There is no restriction on the value of `fromIndex`. If it is greater than or equal to the length of this string, it has the same effect as if it were equal to one less than the length of this string: this entire string may be searched. If it is negative, it has the same effect as if it were -1: -1 is returned.
Returns:
  the index of the last occurrence of the character in the character sequence represented by this object that is less than or equal to `fromIndex`, or `-1` if the character does not occur before that point.

#### indexOf

    public int indexOf(java.lang.String str)

Returns the index within this string of the first occurrence of the specified substring. The integer returned is the smallest value k such that:

>      this.startsWith(str, k)

is `true`.

Specified by:
  `indexOf` in interface `XMLString`
Parameters:
  `str` - any string.
Returns:
  if the string argument occurs as a substring within this object, then the index of the first character of the first such substring is returned; if it does not occur as a substring, `-1` is returned.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`.

#### indexOf

    public int indexOf(XMLString str)

Returns the index within this string of the first occurrence of the specified substring. The integer returned is the smallest value k such that:

>      this.startsWith(str, k)

is `true`.

Specified by:
  `indexOf` in interface `XMLString`
Parameters:
  `str` - any string.
Returns:
  if the string argument occurs as a substring within this object, then the index of the first character of the first such substring is returned; if it does not occur as a substring, `-1` is returned.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`.

#### indexOf

    public int indexOf(java.lang.String str,
              int fromIndex)

Returns the index within this string of the first occurrence of the specified substring, starting at the specified index. The integer returned is the smallest value k such that:

>      this.startsWith(str, k) && (k >= fromIndex)

is `true`.

There is no restriction on the value of `fromIndex`. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: `-1` is returned.

Specified by:
  `indexOf` in interface `XMLString`
Parameters:
  `str` - the substring to search for.
  `fromIndex` - the index to start the search from.
Returns:
  If the string argument occurs as a substring within this object at a starting index no smaller than `fromIndex`, then the index of the first character of the first such substring is returned. If it does not occur as a substring starting at `fromIndex` or beyond, `-1` is returned.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`

#### lastIndexOf

    public int lastIndexOf(java.lang.String str)

Returns the index within this string of the rightmost occurrence of the specified substring. The rightmost empty string "" is considered to occur at the index value `this.length()`. The returned index is the largest value k such that

>      this.startsWith(str, k)

is true.

Specified by:
  `lastIndexOf` in interface `XMLString`
Parameters:
  `str` - the substring to search for.
Returns:
  if the string argument occurs one or more times as a substring within this object, then the index of the first character of the last such substring is returned. If it does not occur as a substring, `-1` is returned.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`.

#### lastIndexOf

    public int lastIndexOf(java.lang.String str,
                  int fromIndex)

Returns the index within this string of the last occurrence of the specified substring.

Specified by:
  `lastIndexOf` in interface `XMLString`
Parameters:
  `str` - the substring to search for.
  `fromIndex` - the index to start the search from. There is no restriction on the value of fromIndex. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: this entire string may be searched. If it is negative, it has the same effect as if it were -1: -1 is returned.
Returns:
  If the string argument occurs one or more times as a substring within this object at a starting index no greater than `fromIndex`, then the index of the first character of the last such substring is returned. If it does not occur as a substring starting at `fromIndex` or earlier, `-1` is returned.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`.

#### substring

    public XMLString substring(int beginIndex)

Returns a new string that is a substring of this string. The substring begins with the character at the specified index and extends to the end of this string.

Examples:

>      "unhappy".substring(2) returns "happy"
>      "Harbison".substring(3) returns "bison"
>      "emptiness".substring(9) returns "" (an empty string)

Specified by:
  `substring` in interface `XMLString`
Parameters:
  `beginIndex` - the beginning index, inclusive.
Returns:
  the specified substring.
Throws:
  `java.lang.IndexOutOfBoundsException` - if `beginIndex` is negative or larger than the length of this `String` object.

#### substring

    public XMLString substring(int beginIndex,
                      int endIndex)

Returns a new string that is a substring of this string. The substring begins at the specified `beginIndex` and extends to the character at index `endIndex - 1`. Thus the length of the substring is `endIndex-beginIndex`.

Specified by:
  `substring` in interface `XMLString`
Parameters:
  `beginIndex` - the beginning index, inclusive.
  `endIndex` - the ending index, exclusive.
Returns:
  the specified substring.
Throws:
  `java.lang.IndexOutOfBoundsException` - if the `beginIndex` is negative, or `endIndex` is larger than the length of this `String` object, or `beginIndex` is larger than `endIndex`.

#### concat

    public XMLString concat(java.lang.String str)

Concatenates the specified string to the end of this string.

Specified by:
  `concat` in interface `XMLString`
Parameters:
  `str` - the `String` that is concatenated to the end of this `String`.
Returns:
  a string that represents the concatenation of this object's characters followed by the string argument's characters.
Throws:
  `java.lang.NullPointerException` - if `str` is `null`.

#### toLowerCase

    public XMLString toLowerCase(java.util.Locale locale)

Converts all of the characters in this `String` to lower case using the rules of the given `Locale`.

Specified by:
  `toLowerCase` in interface `XMLString`
Parameters:
  `locale` - use the case transformation rules for this locale
Returns:
  the String, converted to lowercase.
See Also:
  `Character.toLowerCase(char)`, `String.toUpperCase(Locale)`

#### toLowerCase

    public XMLString toLowerCase()

Converts all of the characters in this `String` to lower case using the rules of the default locale, which is returned by `Locale.getDefault`.

Specified by:
  `toLowerCase` in interface `XMLString`
Returns:
  the string, converted to lowercase.
See Also:
  `Character.toLowerCase(char)`, `String.toLowerCase(Locale)`

#### toUpperCase

    public XMLString toUpperCase(java.util.Locale locale)

Converts all of the characters in this `String` to upper case using the rules of the given locale.

Specified by:
  `toUpperCase` in interface `XMLString`
Parameters:
  `locale` - use the case transformation rules for this locale
Returns:
  the String, converted to uppercase.
See Also:
  `Character.toUpperCase(char)`, `String.toLowerCase(Locale)`

#### toUpperCase

    public XMLString toUpperCase()

Converts all of the characters in this `String` to upper case using the rules of the default locale, which is returned by `Locale.getDefault`.

If no character in this string has a different uppercase version, based on calling the `toUpperCase` method defined by `Character`, then the original string is returned.

Otherwise, this method creates a new `String` object representing a character sequence identical in length to the character sequence represented by this `String` object and with every character equal to the result of applying the method `Character.toUpperCase` to the corresponding character of this `String` object.

Examples:

>      "Fahrvergnügen".toUpperCase() returns "FAHRVERGNÜGEN"
>      "Visit Ljubinje!".toUpperCase() returns "VISIT LJUBINJE!"

Specified by:
  `toUpperCase` in interface `XMLString`
Returns:
  the string, converted to uppercase.
See Also:
  `Character.toUpperCase(char)`, `String.toUpperCase(Locale)`

#### trim

    public XMLString trim()

Removes white space from both ends of this string.

If this `String` object represents an empty character sequence, or the first and last characters of character sequence represented by this `String` object both have codes greater than `'\u0020'` (the space character), then a reference to this `String` object is returned.

Otherwise, if there is no character with a code greater than `'\u0020'` in the string, then a new `String` object representing an empty string is created and returned.

Otherwise, let k be the index of the first character in the string whose code is greater than `'\u0020'`, and let m be the index of the last character in the string whose code is greater than `'\u0020'`. A new `String` object is created, representing the substring of this string that begins with the character at index k and ends with the character at index m-that is, the result of `this.substring(k, m+1)`.

This method may be used to trim `whitespace` from the beginning and end of a string; in fact, it trims all ASCII control characters as well.

Specified by:
  `trim` in interface `XMLString`
Returns:
  this string, with white space removed from the front and end.

#### toString

    public java.lang.String toString()

This object (which is already a string!) is itself returned.

Specified by:
  `toString` in interface `XMLString`
Overrides:
  `toString` in class `java.lang.Object`
Returns:
  the string itself.

#### hasString

    public boolean hasString()

Tell if this object contains a java String object.

Specified by:
  `hasString` in interface `XMLString`
Returns:
  true if this XMLString can return a string without creating one.

#### toDouble

    public double toDouble()

Convert a string to a double -- Allowed input is in fixed notation ddd.fff.

Specified by:
  `toDouble` in interface `XMLString`
Returns:
  A double value representation of the string, or return Double.NaN if the string can not be converted.